//
//  WasabiArtworkManager.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 5/3/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiServiceIdentity.h"
#import "WasabiMetadataFields.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiArtworkManagerGUID;
FOUNDATION_EXTERN CFUUIDRef const WasabiArtworkManagerTypeID;

@protocol WasabiArtworkManager <WasabiDispatchable, WasabiServiceIdentity>

@required


- (NSDictionary *)valuesForKeys:(NSSet *)keys
						 forURL:(NSURL *)anURL
					   andField:(WasabiMetadataField)aField;

- (NSDictionary *)valuesForKeys:(NSSet *)keys
						 forURL:(NSURL *)anURL
					   andField:(WasabiMetadataField)aField
						  error:(NSError **)error;

- (NSDictionary *)albumCoverForKeys:(NSSet *)keys
							 forURL:(NSURL *)anURL;
- (NSDictionary *)albumCoverForKeys:(NSSet *)keys
							 forURL:(NSURL *)anURL
							  error:(NSError **)error;


@end
