//
//  WasabiMetadata.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiMetadataFields.h"


@protocol WasabiMetadata <WasabiDispatchable>

@required

- (NSString *)stringValueFromField:(WasabiMetadataField)aField;
- (NSString *)stringValueFromField:(WasabiMetadataField)aField
						   atIndex:(unsigned int)anIndex
							 error:(NSError **)error;

- (long long)longLongValueFromField:(WasabiMetadataField)aField;
- (long long)longLongValueFromField:(WasabiMetadataField)aField
							atIndex:(unsigned int)anIndex
							  error:(NSError **)error;

- (double)doubleValueFromField:(WasabiMetadataField)aField;
- (double)doubleValueFromField:(WasabiMetadataField)aField
					   atIndex:(unsigned int)anIndex
						 error:(NSError **)error;

- (NSDictionary *)artworkValuesForKeys:(NSSet *)keys
							 fromField:(WasabiMetadataField)aField;
- (NSDictionary *)artworkValuesForKeys:(NSSet *)keys
							 fromField:(WasabiMetadataField)aField
							   atIndex:(unsigned int)anIndex
								 error:(NSError **)errorCode;

- (NSDictionary *)binaryValuesForKeys:(NSSet *)keys
							fromField:(WasabiMetadataField)aField;
- (NSDictionary *)binaryValuesForKeys:(NSSet *)keys
							fromField:(WasabiMetadataField)aField
							  atIndex:(unsigned int)anIndex
								error:(NSError **)errorCode;


- (id<WasabiMetadata>)metadataValueFromField:(WasabiMetadataField)aField;
- (id<WasabiMetadata>)metadataValueFromField:(WasabiMetadataField)aField
									 atIndex:(unsigned int)anIndex
									   error:(NSError **)error;

- (NSData *)serialize;
- (NSData *)serializeAndReturnError:(NSError **)error;

@end
