//
//  WasabiMetadataEditor.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiMetadataFields.h"

@protocol WasabiMetadataEditor <WasabiDispatchable>

@required

- (BOOL)save;
- (BOOL)saveWithError:(NSError **)error;

- (BOOL)setStringValue:(NSString *)value
			  forField:(WasabiMetadataField)field
			 withIndex:(unsigned int)index
				 error:(NSError **)error;


- (BOOL)setLongLongValue:(long long)value
				forField:(WasabiMetadataField)field
			   withIndex:(unsigned int)index
				   error:(NSError **)error;

- (BOOL)setDoubleValue:(double)value
			  forField:(WasabiMetadataField)field
			 withIndex:(unsigned int)index
				 error:(NSError **)error;

- (BOOL)setArtValue:(NSData *)value
		   forField:(WasabiMetadataField)field
		  withIndex:(unsigned int)index
		   mimeType:(NSString *)mimeType
		description:(NSString *)description
			  width:(unsigned int)width
			 height:(unsigned int)height
			  error:(NSError **)error;

@end
